#include "dag.h"
#include <stdlib.h>
#include <iostream>
#define ALLOC_STEP_PARENT 1
#define ALLOC_STEP_CHILD 2
//adds a new parent to the current node, returns -1 on fail else index of added parent
int Node::addParent(int parent)
{
    if(allocParents==numParents)
    {
	allocParents+=ALLOC_STEP_PARENT;
	parents=(int *)realloc(parents,allocParents*sizeof(int));
	if(!parents)
	{
	    std::cout<<"Failed to allocate memory\n";
	    return -1;
	}
    }
    parents[numParents++]=parent;
    return parent;
}

//adds a new parent to the current node, returns -1 on fail else index of added parent
int Node::addChild(int child)
{
    if(allocChildren==numChildren)
    {
	if(type==NOT)
	    allocChildren+=1;
	else //AND
	    allocChildren+=ALLOC_STEP_CHILD;
	children=(int *)realloc(children,allocChildren*sizeof(int));
	if(!children)
	{
	    std::cout<<"Failed to allocate memory\n";
	    return -1;
	}
    }
    children[numChildren++]=child;
    return child;
}

int Node::getParent(int p)
{
    if(p>=numParents || p<0)
	return -1;
    else
	return parents[p];
}

int Node::getChild(int c)
{
    if(c>=numChildren || c<0)
	return -1;
    else
	return children[c];
}

Node::~Node()
{
    if(parents)
	free(parents);
    if(children)
	free(children);
}

Negation::Negation(int child)
{
    type=NOT;
    Node::addChild(child);
}

Conjunction::Conjunction(int lChild, int rChild)
{
    type=AND;
    Node::addChild(lChild);
    Node::addChild(rChild);
}
