#ifndef NODE_DAG
#define NODE_DAG

extern "C"
{
#include "aiger.h"
}
enum nodeType { AND, NOT, VAR};

class Node
{
public:
    Node(){numParents=0;parents=NULL;numChildren=0;children=NULL;allocParents=0;allocChildren=0;
	   visited=0;}
    ~Node();

    nodeType getType() {return type;}
//    int *getParents(int &nParents) {nParents=numParents; return parents;}
//    int *getChildren(int &nChildren) {nChildren=numChildren; return children;}
    int addParent(int parent);
    int addChild(int child);
    int getNumParents() {return numParents;}
    int getNumChildren() {return numChildren;}
    int getParent(int p);
    int getChild(int c);
    int getVisited() {return visited;}
    void increaseVisited() {visited++;}
    void resetVisited(){visited=0;}
protected:
    nodeType type;
    int numParents;
    int *parents;
    int numChildren;
    int *children;
    int allocParents;
    int allocChildren;
    int visited;

};

class Variable : public Node
{
public:
    Variable():Node() {type=VAR;}
    ~Variable();
    int addChild(int child){return child;}
    void increaseVisitedChildren(){}
};


class Negation : public Node
{
public:
    //Negation();
    Negation(int child);
    ~Negation();
    int addChild(int child){return child;}
};

class Conjunction : public Node
{
public:
    //Conjunction();
    Conjunction(int lChild, int rChild);
    ~Conjunction();
};
#endif
